//==========================================================================
//	scope.h
//	Author: David Quijano, Juan Castillo, Héctor Posadas
//	Date: mar mar 4 2008
//	Description:
//==========================================================================
//  The following code is derived, directly or indirectly, from SCoPE,
//  released June 30, 2008. Copyright (C) 2006 Design of Systems on Silicon (DS2)
//  The Initial Developer of the Original Code is the University of Cantabria
//  for Design of Systems on Silicon (DS2)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License (GPL) or GNU Lesser General Public License(LGPL) as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License (GPL) or GNU Lesser General Public License(LGPL) for more details.
//
//  You should have received a copy of the GNU General Public License (GPL) or GNU Lesser General Public License(LGPL)
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//  For more information about SCOPE you can visit
//  http://www.teisa.unican.es/scope or write an e-mail to
//  scope@teisa.unican.es or a letter to SCoPE, GIM - TEISA, University
//  of Cantabria, AV. Los Castros s/n, ETSIIT, 39005, Santander, Spain
//==========================================================================

/*!
 * \file scope.h
 * \brief Definitions to use Scope with user code
 *
 * This file is included in the user code by the preprocessor
 * command line. The command line is formed by the scope
 * compiler.
 */
#ifndef _UC_SCOPE_H_
#define _UC_SCOPE_H_

//System headers:
#include <stdio.h>
#include <time.h>

//Definitions for code execution:
extern unsigned long long uc_segment_time;
extern unsigned long long uc_segment_instr;
// class UC_rtos_class;
// class UC_process_class;
// extern __thread UC_rtos_class *qt_parent_rtos;
// extern __thread UC_process_class *qt_parent_process;

void uc_user_sc_stop();

#endif /* _UC_SCOPE_H_ */
